unit uBizCuentasEspeciales;

interface

uses
  uDAInterfaces, uDADataTable, uDBSelectionListUtils, schContabilidadClient_Intf;

const
  BIZ_CLIENT_CuentaEspecial = 'Client.CuentaEspecial';

type
  IBizCuentaEspecial = interface(ICuentasEspeciales)
    ['{F79E3238-1E0D-4FB6-9AF7-E5703619B067}']
    function EsNuevo : Boolean;
  end;

  TBizCuentaEspecial = class(TCuentasEspecialesDataTableRules, IBizCuentaEspecial, ISeleccionable)
  protected
    FSeleccionableInterface : ISeleccionable;
    procedure OnNewRecord(Sender: TDADataTable); override;
  public
    property SeleccionableInterface : ISeleccionable read FSeleccionableInterface
        write FSeleccionableInterface implements ISeleccionable;

    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

    procedure IniciarValoresCuentaEspecialNueva;
    function EsNuevo : Boolean;
  end;

implementation

{ TBizCuentaEspecial }

uses
  SysUtils, uDataTableUtils;

constructor TBizCuentaEspecial.Create(aDataTable: TDADataTable);
begin
  inherited;
  FSeleccionableInterface := TSeleccionable.Create(aDataTable);
end;

destructor TBizCuentaEspecial.Destroy;
begin
  FSeleccionableInterface := NIL;
  inherited;
end;

function TBizCuentaEspecial.EsNuevo: Boolean;
begin
  Result := (ID < 0);
end;

procedure TBizCuentaEspecial.IniciarValoresCuentaEspecialNueva;
begin
  //
end;

procedure TBizCuentaEspecial.OnNewRecord(Sender: TDADataTable);
begin
  inherited;
  IniciarValoresCuentaEspecialNueva;
end;

initialization
  RegisterDataTableRules(BIZ_CLIENT_CuentaEspecial, TBizCuentaEspecial);

finalization

end.

